namespace View_by_Distance.Shared.Models.Stateless.Methods;

public interface IPersonBirthday
{

    DateTime TestStatic_GetDefaultValue() =>
        PersonBirthday.GetDefaultValue(); // {{1}}SingletonValue

    static DateTime GetDefaultValue() =>
        PersonBirthday.GetDefaultValue(); // {{1}}SingletonValue

    // ...

    double? TestStatic_GetAge(Models.PersonBirthday birthday);
    static double? GetAge(Models.PersonBirthday birthday) =>
        PersonBirthday.GetAge(birthday);

    DateTime? TestStatic_GetDateTime(string personKey) =>
        PersonBirthday.GetDateTime(personKey);
    static DateTime? GetDateTime(string personKey) =>
        PersonBirthday.GetDateTime(personKey);

    string TestStatic_GetFileName(Models.PersonBirthday personBirthday) =>
        PersonBirthday.GetFileName(personBirthday);
    static string GetFileName(Models.PersonBirthday personBirthday) =>
        PersonBirthday.GetFileName(personBirthday);

    (int, TimeSpan) TestStatic_GetAge(DateTime dateTime, Models.PersonBirthday birthday);
    static (int, TimeSpan) GetAge(DateTime dateTime, Models.PersonBirthday birthday) =>
        PersonBirthday.GetAge(dateTime, birthday);

    string TestStatic_GetFormatted(Models.PersonBirthday personBirthday) =>
        PersonBirthday.GetFormatted(personBirthday);
    static string GetFormatted(Models.PersonBirthday personBirthday) =>
        PersonBirthday.GetFormatted(personBirthday);

    Models.PersonBirthday? TestStatic_GetPersonBirthday(string personKey) =>
        PersonBirthday.GetPersonBirthday(personKey);
    static Models.PersonBirthday? GetPersonBirthday(string personKey) =>
        PersonBirthday.GetPersonBirthday(personKey);

    Models.PersonBirthday TestStatic_GetNextBirthDate(Properties.IStorage storage) =>
        PersonBirthday.GetNextBirthDate(storage);
    static Models.PersonBirthday GetNextBirthDate(Properties.IStorage storage) =>
        PersonBirthday.GetNextBirthDate(storage);

    TimeSpan? TestStatic_Get(DateTime now, Models.PersonBirthday personBirthday) =>
        PersonBirthday.GetTimeSpan(now, isWrongYear: false, personBirthday);
    static TimeSpan? GetTimeSpan(DateTime minimumDateTime, Models.PersonBirthday personBirthday) =>
        PersonBirthday.GetTimeSpan(minimumDateTime, isWrongYear: false, personBirthday);

    string TestStatic_GetFileFullName(Properties.IStorage storage, Models.PersonBirthday personBirthday) =>
        PersonBirthday.GetFileFullName(storage, personBirthday);
    static string GetFileFullName(Properties.IStorage storage, Models.PersonBirthday personBirthday) =>
        PersonBirthday.GetFileFullName(storage, personBirthday);

    bool TestStatic_DoesBirthDateExits(Properties.IStorage storage, Models.PersonBirthday personBirthday) =>
        DoesBirthDateExits(storage, personBirthday);
    static bool DoesBirthDateExits(Properties.IStorage storage, Models.PersonBirthday personBirthday) =>
        DoesBirthDateExits(storage, personBirthday);

    TimeSpan? TestStatic_Get(DateTime minimumDateTime, bool? isWrongYear, Models.PersonBirthday personBirthday) =>
        PersonBirthday.GetTimeSpan(minimumDateTime, isWrongYear, personBirthday);
    static TimeSpan? GetTimeSpan(DateTime minimumDateTime, bool? isWrongYear, Models.PersonBirthday personBirthday) =>
        PersonBirthday.GetTimeSpan(minimumDateTime, isWrongYear, personBirthday);

}